﻿using Microsoft.Extensions.DependencyInjection;
using Netmash.Infrastructure.Messaging.Services;

namespace Netmash.Infrastructure.Messaging.Abstractions
{
    public static class DependencyInjectionExtensions
    {
        public static IServiceCollection AddMessageBus(this IServiceCollection services)
        {
            services.AddSingleton<IMessageBusPublisher, MessageBusPublisher>();
            //   services.AddSingleton<IMessageBusSubscriber, MessageBusSubscriber>();
            services.AddSingleton<ITopicRegistry, DefaultTopicRegistry>();
            services.AddSingleton<IMessageSerDes, NewtonsoftJsonMessageSerDes>();
            services.AddSingleton<IMessageTypeRegistry, DefaultMessageTypeRegistry>();
            //   services.AddSingleton<IMessageBus, MessageBus>();
            // services.AddSingleton<IDeadLetterQueue, DefaultDeadLetterQueue>();

            return services;
        }
    }
}
