﻿using Netmash.Infrastructure.Messaging.Models;
using System.Threading;
using System.Threading.Tasks;

namespace Netmash.Infrastructure.Messaging.Abstractions
{
    public interface IMessageBusPublisher
    {
        Task PublishAsync<T>(T message, MessagingPublisherOptions publisherOptions = null,
            CancellationToken cancellationToken = default);

        Task PublishAsync<T>(T message, CancellationToken cancellationToken) =>
            PublishAsync(message, null, cancellationToken);
    }
}
